'use strict';

var _reactTransformHmr2 = require('react-transform-hmr');

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _reactTransformHmr3 = _interopRequireDefault(_reactTransformHmr2);

var _react = require('react');

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireWildcard = require('babel-runtime/helpers/interop-require-wildcard')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _react2 = _interopRequireDefault(_react);

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _shapes = require('./shapes');

var shapes = _interopRequireWildcard(_shapes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jss = require('jss');

var _jssNested = require('jss-nested');

var _jssNested2 = _interopRequireDefault(_jssNested);

var _jssVendorPrefixer = require('jss-vendor-prefixer');

var _jssVendorPrefixer2 = _interopRequireDefault(_jssVendorPrefixer);

var _utilsFindMatchingTextIndex = require('./utils/findMatchingTextIndex');

var _utilsFindMatchingTextIndex2 = _interopRequireDefault(_utilsFindMatchingTextIndex);

var _filters = require('./filters');

var filters = _interopRequireWildcard(_filters);

var _components = {
  _$Dropdown: {
    displayName: 'Dropdown'
  }
};

var _reactComponentWrapper = (0, _reactTransformHmr3['default'])({
  filename: 'src/Dropdown.jsx',
  components: _components,
  locals: [module],
  imports: [_react]
});

function _wrapComponent(uniqueId) {
  return function (ReactClass) {
    return _reactComponentWrapper(ReactClass, uniqueId);
  };
}

var jss = (0, _jss.create)();
jss.use((0, _jssNested2['default'])());
jss.use((0, _jssVendorPrefixer2['default'])());

function isStatic(opt) {
  return opt === null || opt['static'] === true;
}

function getOptionText(opt) {
  return (typeof opt === 'string' || !opt ? opt : opt.text || opt.value) || '';
}

function getOptionValue(opt) {
  return typeof opt === 'string' || !opt ? opt : opt.value;
}

function getOptionLabel(opt) {
  return typeof opt === 'string' || !opt ? opt : opt.label || opt.text || opt.value;
}

function getOptionClassName(opt, isHighlighted, isDisabled) {
  return (0, _classnames2['default'])(sheet.classes.option, isHighlighted && sheet.classes.optionHighlighted, isDisabled && sheet.classes.optionDisabled);
}

function getOptionKey(opt, idx) {
  var value = getOptionValue(opt);

  return opt === null ? 'option-separator-' + idx : 'option-' + (typeof value === 'string' ? value : getOptionText(opt) + idx);
}

function getSiblingIndex(idx, options, next) {
  if (idx === null) {
    idx = next ? -1 : options.length;
  }

  var step = next ? 1 : -1;

  for (var i = 0; i < options.length; i++) {
    var currentIdx = (idx + (i + 1) * step + options.length) % options.length;
    if (options[currentIdx] !== null && !options[currentIdx].disabled) {
      return currentIdx;
    }
  }

  return idx;
}

function getShownOptions(value, options, optionFilters) {
  return optionFilters.reduce(function (o, filter) {
    return filter(o, value);
  }, options);
}

function findOptionIndex(options, option) {
  return options.findIndex(function (opt) {
    return opt === option;
  });
}

function getStateFromProps(props) {
  var shownOptions = getShownOptions(null, props.options, props.optionFilters);
  var match = (0, _utilsFindMatchingTextIndex2['default'])(props.value || props.defaultValue, props.options);

  var _match = _slicedToArray(match, 2);

  var selectedIndex = _match[0];
  var matchingText = _match[1];

  var highlightedIndex = findOptionIndex(shownOptions, props.options[selectedIndex]);

  return {
    value: matchingText || null,
    isActive: false,
    listShown: false,
    selectedIndex: selectedIndex,
    highlightedIndex: highlightedIndex,
    shownOptions: shownOptions
  };
}

var Dropdown = (function (_Component) {
  _inherits(Dropdown, _Component);

  function Dropdown(props) {
    var _this = this;

    _classCallCheck(this, _Dropdown);

    _get(Object.getPrototypeOf(_Dropdown.prototype), 'constructor', this).call(this, props);
    this.shouldComponentUpdate = _reactPureRenderFunction2['default'];

    this.renderOption = function (opt, idx) {
      var onRenderOption = _this.props.onRenderOption;

      var highlighted = idx === _this.state.highlightedIndex;
      var disabled = opt && opt.disabled;

      return _react2['default'].cloneElement(onRenderOption(getOptionClassName(opt, highlighted, disabled), null, opt, highlighted), {
        key: getOptionKey(opt, idx),
        ref: function ref(o) {
          return _this.optionRefs['option-' + idx] = o;
        },
        onMouseDown: _this.handleOptionClick.bind(_this, idx)
      });
    };

    this.handleChange = function (e) {
      var _props = _this.props;
      var options = _props.options;
      var optionFilters = _props.optionFilters;

      var value = e.target.value;

      if (_this.props.value === undefined) {
        _this.setState({ value: value });
        _this.updateHighlightedIndex(value, options, optionFilters);
      }
      _this.setState({ textValue: value });

      if (_this.props.onChange) {
        _this.props.onChange(e);
      }
    };

    this.handleKeyDown = function (e) {
      var keyMap = {
        ArrowUp: _this.handleArrowUpKeyDown,
        ArrowDown: _this.handleArrowDownKeyDown,
        Escape: _this.handleEscapeKeyDown,
        Enter: _this.handleEnterKeyDown
      };

      if (keyMap[e.key]) {
        keyMap[e.key](e);
      } else {
        _this.setState({
          listShown: true
        });
      }

      if (_this.props.onKeyDown) {
        _this.props.onKeyDown(e);
      }
    };

    this.handleArrowUpKeyDown = function (e) {
      var _state = _this.state;
      var highlightedIndex = _state.highlightedIndex;
      var shownOptions = _state.shownOptions;

      e.preventDefault();

      _this.setState({
        highlightedIndex: getSiblingIndex(highlightedIndex, shownOptions, false),
        listShown: true
      });
    };

    this.handleArrowDownKeyDown = function (e) {
      var _state2 = _this.state;
      var highlightedIndex = _state2.highlightedIndex;
      var shownOptions = _state2.shownOptions;

      e.preventDefault();

      _this.setState({
        highlightedIndex: getSiblingIndex(highlightedIndex, shownOptions, true),
        listShown: true
      });
    };

    this.handleEscapeKeyDown = function () {
      _this.setState({
        listShown: false
      });
    };

    this.handleEnterKeyDown = function () {
      var _state3 = _this.state;
      var highlightedIndex = _state3.highlightedIndex;
      var shownOptions = _state3.shownOptions;

      var option = shownOptions[highlightedIndex];

      _this.setState({
        listShown: false
      }, function () {
        _this.selectOption(findOptionIndex(_this.props.options, option), true);
      });
    };

    this.handleFocus = function () {
      _this.setState({
        isActive: true,
        listShown: true
      });
    };

    this.handleBlur = function () {
      var selectedIndex = _this.state.selectedIndex;

      _this.setState({
        isActive: false,
        listShown: false
      }, function () {
        _this.selectOption(selectedIndex, false);
      });
    };

    this.optionRefs = {};

    this.state = getStateFromProps(props);
  }

  _createClass(Dropdown, [{
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      var options = nextProps.options;
      var optionFilters = nextProps.optionFilters;
      var defaultValue = nextProps.defaultValue;
      var value = nextProps.value;

      if ((this.props.defaultValue !== defaultValue || this.props.value !== value) && nextState.value === null) {
        this.setState(getStateFromProps(nextProps));
      } else if (this.props.options !== options || this.props.optionFilters !== optionFilters) {
        var _updateHighlightedIndex = this.updateHighlightedIndex(nextState.value, options, optionFilters);

        var _updateHighlightedIndex2 = _slicedToArray(_updateHighlightedIndex, 2);

        var highlightedIndex = _updateHighlightedIndex2[0];
        var shownOptions = _updateHighlightedIndex2[1];

        var selectedIndex = findOptionIndex(options, shownOptions[highlightedIndex]);

        this.setState({ selectedIndex: selectedIndex });
      }
    }
  }, {
    key: 'updateHighlightedIndex',
    value: function updateHighlightedIndex(value, options, optionFilters) {
      var shownOptions = getShownOptions(value, options, optionFilters);
      var match = (0, _utilsFindMatchingTextIndex2['default'])(value, shownOptions, true);

      var _match2 = _slicedToArray(match, 1);

      var highlightedIndex = _match2[0];

      this.setState({ highlightedIndex: highlightedIndex, shownOptions: shownOptions });

      return [highlightedIndex, shownOptions];
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.state.highlightedIndex !== prevState.highlightedIndex && this.state.highlightedIndex !== null) {
        var optionEl = this.optionRefs['option-' + this.state.highlightedIndex];
        if (optionEl) {
          var optionHeight = optionEl.offsetHeight;
          var listEl = optionEl.parentNode;
          var listHeight = listEl.clientHeight;
          listEl.scrollTop = optionEl.offsetTop - (listHeight - optionHeight) / 2;
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var dropdownClassName = _props2.dropdownClassName;
      var onRenderCaret = _props2.onRenderCaret;
      var onRenderList = _props2.onRenderList;
      var onRenderListHeader = _props2.onRenderListHeader;
      var dropdownStyle = _props2.dropdownStyle;
      var dropdownProps = _props2.dropdownProps;
      var options = _props2.options;
      var classes = sheet.classes;
      var _state4 = this.state;
      var shownOptions = _state4.shownOptions;
      var isActive = _state4.isActive;
      var hover = _state4.hover;
      var listShown = _state4.listShown;

      var caret = _react2['default'].createElement(
        'svg',
        { width: '10', height: '5', fill: 'currentColor' },
        _react2['default'].createElement('path', { d: 'M0 0 H10 L5 5 z' })
      );
      var caretClassName = (0, _classnames2['default'])(classes.caret, hover && classes.caretActive);
      var listClassName = (0, _classnames2['default'])(classes.list, isActive && classes.listActive);

      return _react2['default'].createElement(
        'div',
        _extends({ className: (0, _classnames2['default'])(classes.dropdown, dropdownClassName),
          style: dropdownStyle,
          onFocus: this.handleFocus,
          onBlur: this.handleBlur,
          onMouseEnter: function () {
            return _this2.setState({ hover: true });
          },
          onMouseLeave: function () {
            return _this2.setState({ hover: false });
          },
          ref: 'dropdown'
        }, dropdownProps),
        this.renderInput(),
        onRenderCaret(caretClassName, null, isActive, caret),
        onRenderList(listClassName, null, isActive, listShown, shownOptions.map(this.renderOption), onRenderListHeader(options.length, shownOptions.length, shownOptions.filter(isStatic).length))
      );
    }
  }, {
    key: 'renderInput',
    value: function renderInput() {
      var _props3 = this.props;
      var dropdownClassName = _props3.dropdownClassName;
      var onRenderCaret = _props3.onRenderCaret;
      var onRenderList = _props3.onRenderList;
      var className = _props3.className;
      var style = _props3.style;
      var children = _props3.children;
      var onValueChange = _props3.onValueChange;

      var props = _objectWithoutProperties(_props3, ['dropdownClassName', 'onRenderCaret', 'onRenderList', 'className', 'style', 'children', 'onValueChange']);

      var classes = sheet.classes;

      var selectedOption = this.state.shownOptions[this.state.highlightedIndex];

      var inputProps = _extends({}, props, {
        value: this.state.isActive ? this.state.value : getOptionText(selectedOption),
        defaultValue: null,
        className: (0, _classnames2['default'])(classes.input, className),
        onKeyDown: this.handleKeyDown,
        onChange: this.handleChange,
        style: {
          paddingRight: '15px'
        }
      });

      if (typeof children === 'function') {
        return children(inputProps, {
          textValue: this.state.textValue
        });
      } else {
        var input = _react.Children.only(children);

        return _react2['default'].cloneElement(input, _extends({}, inputProps, input.props));
      }
    }
  }, {
    key: 'handleOptionClick',
    value: function handleOptionClick(idx) {
      var _this3 = this;

      var option = this.state.shownOptions[idx];
      this.setState({
        listShown: false
      }, function () {
        _this3.selectOption(findOptionIndex(_this3.props.options, option), true);
      });
    }
  }, {
    key: 'selectOption',
    value: function selectOption(index, fireOnChange) {
      var _props4 = this.props;
      var options = _props4.options;
      var optionFilters = _props4.optionFilters;

      var option = options[index];
      var shownOptions = getShownOptions(getOptionText(option), options, optionFilters);

      this.setState({
        value: getOptionText(option),
        textValue: getOptionText(option),
        highlightedIndex: findOptionIndex(shownOptions, option),
        selectedIndex: index,
        shownOptions: shownOptions
      });
      if (fireOnChange && this.props.onValueChange) {
        this.props.onValueChange(getOptionValue(option), getOptionText(option));
      }
    }
  }], [{
    key: 'propTypes',
    value: {
      value: _react.PropTypes.string,
      options: _react.PropTypes.arrayOf(shapes.ITEM_OR_STRING),
      onRenderOption: _react.PropTypes.func,
      onRenderCaret: _react.PropTypes.func,
      onRenderList: _react.PropTypes.func,
      optionFilters: _react.PropTypes.arrayOf(_react.PropTypes.func)
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      onRenderOption: function onRenderOption(className, style, opt) {
        return opt !== null ? _react2['default'].createElement(
          'div',
          { className: className, style: style },
          getOptionLabel(opt)
        ) : _react2['default'].createElement('div', { className: sheet.classes.separator });
      },

      onRenderCaret: function onRenderCaret(className, style, isActive, children) {
        return _react2['default'].createElement(
          'div',
          { className: className, style: style },
          children
        );
      },

      onRenderList: function onRenderList(className, style, isActive, listShown, children, header) {
        return listShown && _react2['default'].createElement(
          'div',
          { className: className, style: style },
          header && _react2['default'].createElement(
            'div',
            { className: sheet.classes.listHeader },
            header
          ),
          _react2['default'].createElement(
            'div',
            { className: sheet.classes.listOptions },
            children
          )
        );
      },

      onRenderListHeader: function onRenderListHeader(allCount, shownCount, staticCount) {
        if (allCount - staticCount < 20) return null;
        var allItems = allCount - staticCount + ' ' + (allCount - staticCount === 1 ? 'item' : 'items');
        return allCount === shownCount ? allItems + ' found' : shownCount - staticCount + ' of ' + allItems + ' shown';
      },

      dropdownProps: {},

      optionFilters: [filters.filterByMatchingTextWithThreshold(20), filters.sortByMatchingText, filters.limitBy(100), filters.notFoundMessage('No matches found'), filters.filterRedudantSeparators]
    },
    enumerable: true
  }]);

  var _Dropdown = Dropdown;
  Dropdown = _wrapComponent('_$Dropdown')(Dropdown) || Dropdown;
  return Dropdown;
})(_react.Component);

exports['default'] = Dropdown;

var sheet = jss.createStyleSheet({
  dropdown: {
    position: 'relative',
    display: 'inline-block'
  },
  caret: {
    position: 'absolute',
    right: '5px',
    top: 0,
    'padding-top': '5px',
    'vertical-align': 'middle',
    'padding-left': '3px',
    width: '10px',
    '& svg': {
      display: 'inline-block',
      opacity: 0,
      transition: 'opacity 0.15s linear, transform 0.15s linear',
      transform: 'translateY(5px)'
    }
  },
  caretActive: {
    '& svg': {
      opacity: 1,
      transform: 'translateY(0)'
    }
  },
  list: {
    position: 'absolute',
    left: 0,
    top: '100%',
    'z-index': 10000,
    'max-height': '30rem',
    'min-width': '22rem',
    'background-color': '#FFFFFF',
    'box-shadow': '1px 1px 4px rgba(100, 100, 100, 0.3)',
    display: 'flex',
    'flex-direction': 'column'
  },
  listHeader: {
    'flex-shrink': 0,
    height: '3rem',
    'font-size': '0.8em',
    color: '#999999',
    'background-color': '#FAFAFA',
    padding: '0.5rem 1rem',
    'border-bottom': '1px solid #DDDDDD'
  },
  listOptions: {
    'flex-grow': 1,
    'overflow-y': 'auto'
  },
  option: {
    padding: '1rem 1.5rem',
    cursor: 'pointer',
    '&:hover': {
      'background-color': '#F0F0F0'
    }
  },
  optionHighlighted: {
    'background-color': '#3333FF',
    color: '#FFFFFF',
    '&:hover': {
      'background-color': '#3333FF'
    }
  },
  optionDisabled: {
    color: '#999999',
    '&:hover': {
      'background-color': 'inherit'
    }
  },
  separator: {
    margin: '0.5rem 0',
    width: '100%',
    height: '1px',
    'border-top': '1px solid #DDDDDD'
  }
}).attach();
module.exports = exports['default'];