'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = filterByMatchingTextWithThreshold;
function getOptionText(opt) {
  return typeof opt === 'string' ? opt : typeof opt.label === 'string' ? opt.label : opt.text || opt.value;
}

function isStatic(opt) {
  return opt === null || opt['static'] === true;
}

function filterByMatchingTextWithThreshold(threshold) {
  return function (options, value) {
    if (!value || threshold && options.length < threshold) return options;
    value = value.toLowerCase();

    return options.filter(function (opt) {
      return isStatic(opt) || getOptionText(opt).toLowerCase().indexOf(value) !== -1;
    });
  };
}

module.exports = exports['default'];