"use strict";

var _toConsumableArray = require("babel-runtime/helpers/to-consumable-array")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = notFoundMessage;
function isStatic(opt) {
  return opt === null || opt["static"] === true;
}

function getEmptyOption(message) {
  return { label: message, "static": true, disabled: true };
}

function notFoundMessage(message, ignoreStatic) {
  return function (options, value) {
    if (!ignoreStatic) {
      return options.length === 0 && value ? [getEmptyOption(message)] : options;
    }

    var staticOptions = options.filter(isStatic);

    return options.length === staticOptions.length && value ? [].concat(_toConsumableArray(staticOptions), [getEmptyOption(message)]) : options;
  };
}

module.exports = exports["default"];