'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = sortByMatchingText;

var _lodashSortby = require('lodash.sortby');

var _lodashSortby2 = _interopRequireDefault(_lodashSortby);

function getOptionText(opt) {
  return typeof opt === 'string' ? opt : typeof opt.label === 'string' ? opt.label : opt.text || opt.value;
}

function isStatic(opt) {
  return opt === null || opt['static'] === true;
}

function sortByMatchingText(options, value) {
  value = value && value.toLowerCase();

  return (0, _lodashSortby2['default'])(options, function (opt) {
    if (isStatic(opt)) {
      return 0;
    }

    var text = getOptionText(opt).toLowerCase();
    var matching = text.indexOf(value) === 0;
    return matching ? 1 : 2;
  });
}

module.exports = exports['default'];