'use strict';

var _toConsumableArray = require('babel-runtime/helpers/to-consumable-array')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = findMatchingTextIndex;
function getOptionText(opt) {
  return (typeof opt === 'string' || !opt ? opt : opt.text || opt.value) || '';
}

function isEmpty(value) {
  return value === null || value === '';
}

function findMatchingTextIndex(value, options, allMatches) {
  var lowerText = value && value.toLowerCase();

  var foundOptions = options.reduce(function (opts, opt, idx) {
    var optValue = opt && opt.hasOwnProperty('value') ? opt.value : typeof opt === 'string' ? opt : null;
    var optText = getOptionText(opt);
    var matchPosition = optText.toLowerCase().indexOf(lowerText);

    if (optValue === value || isEmpty(optValue) && isEmpty(value) || optText && lowerText && (allMatches ? matchPosition !== -1 : matchPosition === 0)) {

      return [].concat(_toConsumableArray(opts), [[idx, optText, optValue, matchPosition]]);
    }

    return opts;
  }, []);

  foundOptions.sort(function (a, b) {
    return a[3] - b[3] || a[1].length - b[1].length;
  });

  return foundOptions.length ? foundOptions[0] : [null, null, null];
}

module.exports = exports['default'];